<?php

/**
 * Plugin name: Image Resizer & Optimizer with GD
 * Based on Cipher's Image Resizer plugin <ferry@cipher.demon.nl>
 *
 * @package imageresizer_gd
 * @version 1.1.0
 * @author Cipher <ferry@cipher.demon.nl>
 * @author MT Jordan <mtjo@ospartners.info>
 * @copyright 2007 <ferry@cipher.demon.nl>
 * @copyright 2008 openSource Partners
 * @license LGPL
 * @revision $Id: imageresizer_gd.php,v 1.1 2008/05/08 08:13:44 mtjo $
 */
 
/** 
* Polish Language File developed by mybboard.pl for Image Resizer 1.1
* Tłumaczenie: hippie
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0 **/ 

$plugins->add_hook( 'parse_message', 'imageresizer_gd_message' );
$plugins->add_hook( 'pre_output_page', 'imageresizer_gd_page' );

function imageresizer_gd_info()
{
    return array(
        'name'          => 'Image Resizer & Optimizer z GD',
        'description'   => 'Zmienia rozmiar i optymalizuje obrazek, jeżeli szerokość lub wielkość pliku jest większa niż ta podana w ustawieniach.',
        'website'       => 'http://mods.mybboard.net/',
        'author'        => 'MT Jordan',
        'version'       => '1.1',
        'guid'          => '3d1f80eabbdc15967e189c3b222ca68a',
        'compatibility' => '14*'
    );
}

function imageresizer_gd_activate()
{
    global $mybb, $db;

    // Add settings
    $settings_group = array(
        'gid'          => 'NULL',
        'name'         => 'imageresizer_gd',
        'title'        => 'Image Resizer & Optimizer z GD',
        'description'  => 'Ustawienia Image Resizer & Optimizer z pluginem GD.',
        'disporder'    => '20',
        'isdefault'    => '0'
    );
    $db->insert_query('settinggroups', $settings_group);
    $gid = $db->insert_id();

    $setting = array(
        'sid'          => 'NULL',
        'name'         => 'image_resizer_active',
        'title'        => 'Deaktywować?',
        'description'  => 'Ta opcja daje Ci możliwość deaktywacji pluginu, bez utraty zapisanych ustawień.',
        'optionscode'  => 'yesno',
        'value'        => '0',
        'disporder'    => '1',
        'gid'          => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_resizeroveride',
        'title'       => 'Pomiń dynamiczne skalowanie i optymalizację',
        'description' => 'Ta opcja pomija dynamiczne działanie GD i statycznie skaluje obrazek. Ustaw to na "Tak" jeśli Twój host wyłączył funkcję fopen i nie pozwala na pomijanie .htaccess.',
        'optionscode' => 'yesno',
        'value'       => '0',
        'disporder'   => '2',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_maxwidth',
        'title'       => 'Maksymalna szerokość',
        'description' => 'Jaka jest maksymalna dozwolona szerokość dla obrazka w poście?',
        'optionscode' => 'text',
        'value'       => '500',
        'disporder'   => '3',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_resizewidth',
        'title'       => 'Szerokość skalowania',
        'description' => 'Do jakiej szerokości mają być skalowane obrazki, jeśli przekraczają maksymalną szerokość?',
        'optionscode' => 'text',
        'value'       => '500',
        'disporder'   => '4',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_maxsize',
        'title'       => 'Maksymalny rozmiar pliku',
        'description' => 'Jaki jest maksymalny dozwolony rozmiar pliku przed optymalizacją obrazka, niezależnie od szerokości?',
        'optionscode' => 'text',
        'value'       => '30000',
        'disporder'   => '5',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_animwidth',
        'title'       => 'Maksymalna szerokość dla animowanego GIF-a',
        'description' => 'Jaka jest maksymalna dozwolona szerokość dla animowanego GIF-a?',
        'optionscode' => 'text',
        'value'       => '500',
        'disporder'   => '6',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_animsize',
        'title'       => 'Maksymalny rozmiar animowanego GIF-a',
        'description' => 'Jaki jest maksymalny dozwolony rozmiar animowanego GIF-a, zanim będzie on zmniejszony, niezależnie od szerokości?',
        'optionscode' => 'text',
        'value'       => '30000',
        'disporder'   => '7',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_showwarning',
        'title'       => 'Pokazuj ostrzeżenie',
        'description' => 'Użytkownicy mają być ostrzegani przed wyświetleniem pełnorozmairowego obrazka przez link wiadomości?',
        'optionscode' => 'yesno',
        'value'       => '1',
        'disporder'   => '8',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_borderstyle',
        'title'       => 'Styl obramowania ostrzeżenia',
        'description' => 'Jakie powinno być obramowanie dla obrazka, kiedy jest skalowany? Ustaw na 0, by nie było obramowania.',
        'optionscode' => 'text',
        'value'       => '1px dotted #ff0000',
        'disporder'   => '9',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_warning',
        'title'       => 'Treść ostrzeżenia',
        'description' => 'Jaka powinna być treść ostrzeżenia?',
        'optionscode' => 'text',
        'value'       => 'Obrazek wykracza poza limity. Kliknij, by wyświetlić obrazek w pełnych wymiarach',
        'disporder'   => '10',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_warningcolor',
        'title'       => 'Kolor tekstu ostrzeżenia',
        'description' => 'Jaki powinien być kolor tekstu ostrzeżenia?',
        'optionscode' => 'text',
        'value'       => '#ffffff',
        'disporder'   => '11',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );

    $setting = array(
        'sid'         => 'NULL',
        'name'        => 'image_resizer_warningbackground',
        'title'       => 'Tło ostrzeżenia',
        'description' => 'Jaki powinien być kolor tła ostrzeżnia?',
        'optionscode' => 'text',
        'value'       => '#ff0000',
        'disporder'   => '12',
        'gid'         => intval( $gid )
    );
    $db->insert_query( 'settings', $setting );
}

function imageresizer_gd_deactivate()
{
    global $db;

    //DELETE ALL SETTINGS
    $db->query( "DELETE FROM " . TABLE_PREFIX . "settings WHERE name IN('image_resizer_active','image_resizer_resizeroveride','image_resizer_maxwidth','image_resizer_resizewidth','image_resizer_maxsize','image_resizer_animwidth','image_resizer_animsize','image_resizer_borderstyle','image_resizer_showwarning','image_resizer_warning','image_resizer_warningcolor','image_resizer_warningbackground')" );
    $db->query( "DELETE FROM " . TABLE_PREFIX . "settinggroups WHERE name='imageresizer_gd'" );
}

function imageresizer_gd_message( $message )
{
    global $mybb;

    if ( $mybb->settings['image_resizer_active'] == '1' )
    {
        $pattern = '#<img(.*?)/>#';
        $replace = '<img class="postimage"$1/>';
        $message = preg_replace( $pattern, $replace, $message );
    }

    return $message;
}

function imageresizer_gd_page( $page )
{
    global $mybb;

    if ( $mybb->settings['image_resizer_active'] == '1' )
    {
        $page = str_replace( '</body>', imageresizer_gd_javascript().'</body>', $page );
    }

    return $page;
}

function imageresizer_gd_javascript()
{
    global $mybb;

    $maxwidth = $mybb->settings['image_resizer_maxwidth'];
    $maxsize = $mybb->settings['image_resizer_maxsize'];
    $animwidth = $mybb->settings['image_resizer_animwidth'];
    $animsize = $mybb->settings['image_resizer_animsize'];
    $resizewidth = $mybb->settings['image_resizer_resizewidth'];
    $borderstyle = $mybb->settings['image_resizer_borderstyle'];
    $setwarning = ( int ) $mybb->settings['image_resizer_showwarning'];
    $warning = $mybb->settings['image_resizer_warning'];
    $warningcolor = $mybb->settings['image_resizer_warningcolor'];
    $warningbackground = $mybb->settings['image_resizer_warningbackground'];
    $resizerEngineURL = $mybb->settings['bburl'] . '/inc/plugins/resizer_class/resizer_class.php';
    $resizeroveride = (int) $mybb->settings['image_resizer_resizeroveride'];

    $jscript = '<script type="text/javascript">' . "\n" .
               '<!--' . "\n" .
               'function resize_images() {' . "\n" .
               'var img = $$( "img.postimage" );' . "\n" .
               'for ( var i = 0; i < img.length; i++ ) {' . "\n" .
               'while ( !img[i].complete ) { break; }' . "\n" .
               'if ( img[i].width > ' . $maxwidth . ' ) {' . "\n" .
               'var imgURL = img[i].getAttribute( "src" );' . "\n";

    if ( $resizeroveride )
    {
        $jscript .= 'var oldWidth = img[i].width;' . "\n" .
                    'var oldHeight = img[i].height;' . "\n" .
                    'img[i].width = ' . $resizewidth . ';' . "\n" .
                    'img[i].height = oldHeight * ( ' . $resizewidth . ' / oldWidth )' . "\n";
    }
    else
    {
         $jscript .= 'img[i].setAttribute( "src", "' . $resizerEngineURL . '?filename="+ imgURL +"&newwidth=' . $resizewidth . '&maxsize=' . $maxsize . '&maxwidth=' . $maxwidth . '&animwidth=' . $animwidth . '&animsize=' . $animsize . '" );' . "\n";
    }

    $jscript .= 'img[i].setAttribute( "alt", imgURL );' . "\n" .
                'img[i].setAttribute( "title", imgURL );' . "\n";

    if ( $setwarning )
    {
        if ( trim( $borderstyle ) != '' )
        {
            $jscript .= 'img[i].style.borderTop = "' . $borderstyle . '";' . "\n" .
                        'img[i].style.borderLeft = "' . $borderstyle . '";' . "\n" .
                        'img[i].style.borderRight = "' . $borderstyle . '";' . "\n";
        }

        $jscript .= 'var parent = img[i].parentNode;' . "\n" .
                    'var warning = document.createElement( "div" );' . "\n" .
                    'var align = parent.getAttribute( "style" );' . "\n" .
                    'var setalign = "";' . "\n" .
                    'if ( align == "text-align: center;" || align == "text-align: right;" ) {' . "\n" .
                    'if ( align == "text-align: center;" ) setalign = "center";' . "\n" .
                    'if ( align == "text-align: right;" ) setalign = "right"; }' . "\n" .
                    'warning.innerHTML = "<div style=\"background:' . $warningbackground . ';padding:3px 0;text-align:center;width:' . $resizewidth  . 'px;\"><a href=\"" + imgURL + "\" target=\"_blank\" style=\"font-weight:bold;color: ' . $warningcolor . ';\">' . $warning . '</a></div>";' . "\n" .
                    'warning.setAttribute( "align", setalign );' . "\n" .
                    'parent.insertBefore( warning, img[i].nextSibling );' . "\n";
    }

    $jscript .= '}}}' . "\n" .
                'document.onload = resize_images();' . "\n" .
                '-->' . "\n" .
                '</script>' . "\n";

    return $jscript;
}

?>
